diff -r f77229934d59 src/org/armedbear/lisp/Pathname.java
--- a/src/org/armedbear/lisp/Pathname.java	Tue Jan 26 12:30:57 2010 +0100
+++ b/src/org/armedbear/lisp/Pathname.java	Tue Jan 26 12:34:38 2010 +0100
@@ -625,197 +761,178 @@
     }
 
     // "one or more uppercase letters, digits, and hyphens"
-    protected static String getHostString(String s)
-    {
+    protected static String getHostString(String s) {
         int colon = s.indexOf(':');
-        if (colon >= 0)
+        if (colon >= 0) {
             return s.substring(0, colon).toUpperCase();
-        else
+        } else {
             return null;
+        }
     }
 
-    private static final void checkCaseArgument(LispObject arg)
-
-    {
-        if (arg != Keyword.COMMON && arg != Keyword.LOCAL)
+    private static final void checkCaseArgument(LispObject arg) {
+        if (arg != Keyword.COMMON && arg != Keyword.LOCAL) {
             type_error(arg, list(Symbol.MEMBER, Keyword.COMMON,
-                                       Keyword.LOCAL));
+              Keyword.LOCAL));
+        }
     }
-
     // ### %pathname-host
     private static final Primitive _PATHNAME_HOST =
-        new Primitive("%pathname-host", PACKAGE_SYS, false)
-    {
-        @Override
-        public LispObject execute(LispObject first, LispObject second)
+      new Primitive("%pathname-host", PACKAGE_SYS, false) {
 
-        {
-            checkCaseArgument(second);
-            return coerceToPathname(first).host;
-        }
-    };
-
+          @Override
+          public LispObject execute(LispObject first, LispObject second) {
+              checkCaseArgument(second);
+              return coerceToPathname(first).host;
+          }
+      };
     // ### %pathname-device
     private static final Primitive _PATHNAME_DEVICE =
-        new Primitive("%pathname-device", PACKAGE_SYS, false)
-    {
-        @Override
-        public LispObject execute(LispObject first, LispObject second)
+      new Primitive("%pathname-device", PACKAGE_SYS, false) {
 
-        {
-            checkCaseArgument(second);
-            return coerceToPathname(first).device;
-        }
-    };
-
+          @Override
+          public LispObject execute(LispObject first, LispObject second) {
+              checkCaseArgument(second);
+              return coerceToPathname(first).device;
+          }
+      };
     // ### %pathname-directory
     private static final Primitive _PATHNAME_DIRECTORY =
-        new Primitive("%pathname-directory", PACKAGE_SYS, false)
-    {
-        @Override
-        public LispObject execute(LispObject first, LispObject second)
+      new Primitive("%pathname-directory", PACKAGE_SYS, false) {
 
-        {
-            checkCaseArgument(second);
-            return coerceToPathname(first).directory;
-        }
-    };
-
+          @Override
+          public LispObject execute(LispObject first, LispObject second) {
+              checkCaseArgument(second);
+              return coerceToPathname(first).directory;
+          }
+      };
     // ### %pathname-name
     private static final Primitive _PATHNAME_NAME =
-        new Primitive("%pathname-name", PACKAGE_SYS, false)
-    {
-        @Override
-        public LispObject execute(LispObject first, LispObject second)
+      new Primitive("%pathname-name", PACKAGE_SYS, false) {
 
-        {
-            checkCaseArgument(second);
-            return coerceToPathname(first).name;
-        }
-    };
-
+          @Override
+          public LispObject execute(LispObject first, LispObject second) {
+              checkCaseArgument(second);
+              return coerceToPathname(first).name;
+          }
+      };
     // ### %pathname-type
     private static final Primitive _PATHNAME_TYPE =
-        new Primitive("%pathname-type", PACKAGE_SYS, false)
-    {
-        @Override
-        public LispObject execute(LispObject first, LispObject second)
+      new Primitive("%pathname-type", PACKAGE_SYS, false) {
 
-        {
-            checkCaseArgument(second);
-            return coerceToPathname(first).type;
-        }
-    };
-
+          @Override
+          public LispObject execute(LispObject first, LispObject second) {
+              checkCaseArgument(second);
+              return coerceToPathname(first).type;
+          }
+      };
     // ### pathname-version
     private static final Primitive PATHNAME_VERSION =
-        new Primitive("pathname-version", "pathname")
-    {
-        @Override
-        public LispObject execute(LispObject arg)
-        {
-            return coerceToPathname(arg).version;
-        }
-    };
+      new Primitive("pathname-version", "pathname") {
 
+          @Override
+          public LispObject execute(LispObject arg) {
+              return coerceToPathname(arg).version;
+          }
+      };
     // ### namestring
     // namestring pathname => namestring
     private static final Primitive NAMESTRING =
-        new Primitive("namestring", "pathname")
-    {
-        @Override
-        public LispObject execute(LispObject arg)
-        {
-            Pathname pathname = coerceToPathname(arg);
-            String namestring = pathname.getNamestring();
-            if (namestring == null)
-                error(new SimpleError("Pathname has no namestring: " +
-                                      pathname.writeToString()));
-            return new SimpleString(namestring);
-        }
-    };
+      new Primitive("namestring", "pathname") {
 
+          @Override
+          public LispObject execute(LispObject arg) {
+              Pathname pathname = coerceToPathname(arg);
+              String namestring = pathname.getNamestring();
+              if (namestring == null) {
+                  error(new SimpleError("Pathname has no namestring: "
+                    + pathname.writeToString()));
+              }
+              return new SimpleString(namestring);
+          }
+      };
     // ### directory-namestring
     // directory-namestring pathname => namestring
     private static final Primitive DIRECTORY_NAMESTRING =
-        new Primitive("directory-namestring", "pathname")
-    {
-        @Override
-        public LispObject execute(LispObject arg)
-        {
-            return new SimpleString(coerceToPathname(arg).getDirectoryNamestring());
-        }
-    };
+      new Primitive("directory-namestring", "pathname") {
 
+          @Override
+          public LispObject execute(LispObject arg) {
+              return new SimpleString(coerceToPathname(arg).getDirectoryNamestring());
+          }
+      };
     // ### pathname pathspec => pathname
     private static final Primitive PATHNAME =
-        new Primitive("pathname", "pathspec")
-    {
-        @Override
-        public LispObject execute(LispObject arg)
-        {
-            return coerceToPathname(arg);
-        }
-    };
+      new Primitive("pathname", "pathspec") {
 
+          @Override
+          public LispObject execute(LispObject arg) {
+              return coerceToPathname(arg);
+          }
+      };
     // ### %parse-namestring string host default-pathname => pathname, position
     private static final Primitive _PARSE_NAMESTRING =
-        new Primitive("%parse-namestring", PACKAGE_SYS, false,
-                      "namestring host default-pathname")
-    {
-        @Override
-        public LispObject execute(LispObject first, LispObject second,
-                                  LispObject third)
+      new Primitive("%parse-namestring", PACKAGE_SYS, false,
+      "namestring host default-pathname") {
 
-        {
-            final LispThread thread = LispThread.currentThread();
-            final AbstractString namestring = checkString(first);
-            // The HOST parameter must be a string or NIL.
-            if (second == NIL) {
-                // "If HOST is NIL, DEFAULT-PATHNAME is a logical pathname, and
-                // THING is a syntactically valid logical pathname namestring
-                // without an explicit host, then it is parsed as a logical
-                // pathname namestring on the host that is the host component
-                // of DEFAULT-PATHNAME."
-                third = coerceToPathname(third);
-                if (third instanceof LogicalPathname)
-                    second = ((LogicalPathname)third).host;
-                else
-                    return thread.setValues(parseNamestring(namestring),
-                                            namestring.LENGTH());
-            }
-            Debug.assertTrue(second != NIL);
-            final AbstractString host = checkString(second);
-            return thread.setValues(parseNamestring(namestring, host),
-                                    namestring.LENGTH());
-        }
-    };
-
+          @Override
+          public LispObject execute(LispObject first, LispObject second,
+            LispObject third) {
+              final LispThread thread = LispThread.currentThread();
+              final AbstractString namestring = checkString(first);
+              // The HOST parameter must be a string or NIL.
+              if (second == NIL) {
+                  // "If HOST is NIL, DEFAULT-PATHNAME is a logical pathname, and
+                  // THING is a syntactically valid logical pathname namestring
+                  // without an explicit host, then it is parsed as a logical
+                  // pathname namestring on the host that is the host component
+                  // of DEFAULT-PATHNAME."
+                  third = coerceToPathname(third);
+                  if (third instanceof LogicalPathname) {
+                      second = ((LogicalPathname) third).host;
+                  } else {
+                      return thread.setValues(parseNamestring(namestring),
+                        namestring.LENGTH());
+                  }
+              }
+              Debug.assertTrue(second != NIL);
+              final AbstractString host = checkString(second);
+              return thread.setValues(parseNamestring(namestring, host),
+                namestring.LENGTH());
+          }
+      };
     // ### make-pathname
     private static final Primitive MAKE_PATHNAME =
-        new Primitive("make-pathname",
-                      "&key host device directory name type version defaults case")
-    {
-        @Override
-        public LispObject execute(LispObject[] args)
+      new Primitive("make-pathname",
+      "&key host device directory name type version defaults case") {
 
-        {
-            return _makePathname(args);
-        }
-    };
+          @Override
+          public LispObject execute(LispObject[] args) {
+              return _makePathname(args);
+          }
+      };
 
     // Used by the #p reader.
-    public static final Pathname makePathname(LispObject args)
-
-    {
+    public static final Pathname makePathname(LispObject args) {
         return _makePathname(args.copyToArray());
     }
 
-    private static final Pathname _makePathname(LispObject[] args)
+    public static final Pathname makePathname(File file) {
+        String namestring = null;
+        try {
+            namestring = file.getCanonicalPath();
+        } catch (IOException e) {
+            Debug.trace("Failed to make a Pathname from "
+              + "." + file + "'");
+            return null;
+        }
+        return new Pathname(namestring);
+    }
 
-    {
-        if (args.length % 2 != 0)
+    private static final Pathname _makePathname(LispObject[] args) {
+        if (args.length % 2 != 0) {
             error(new ProgramError("Odd number of keyword arguments."));
+        }
         LispObject host = NIL;
         LispObject device = NIL;
         LispObject directory = NIL;
@@ -828,19 +945,20 @@
         boolean typeSupplied = false;
         for (int i = 0; i < args.length; i += 2) {
             LispObject key = args[i];
-            LispObject value = args[i+1];
+            LispObject value = args[i + 1];
             if (key == Keyword.HOST) {
                 host = value;
             } else if (key == Keyword.DEVICE) {
                 device = value;
                 deviceSupplied = true;
             } else if (key == Keyword.DIRECTORY) {
-                if (value instanceof AbstractString)
+                if (value instanceof AbstractString) {
                     directory = list(Keyword.ABSOLUTE, value);
-                else if (value == Keyword.WILD)
+                } else if (value == Keyword.WILD) {
                     directory = list(Keyword.ABSOLUTE, Keyword.WILD);
-                else
+                } else {
                     directory = value;
+                }
             } else if (key == Keyword.NAME) {
                 name = value;
                 nameSupplied = true;
@@ -852,25 +970,30 @@
             } else if (key == Keyword.DEFAULTS) {
                 defaults = coerceToPathname(value);
             } else if (key == Keyword.CASE) {
-                  // Ignored.
+                // Ignored.
             }
         }
         if (defaults != null) {
-            if (host == NIL)
+            if (host == NIL) {
                 host = defaults.host;
+            }
             directory = mergeDirectories(directory, defaults.directory);
-            if (!deviceSupplied)
+            if (!deviceSupplied) {
                 device = defaults.device;
-            if (!nameSupplied)
+            }
+            if (!nameSupplied) {
                 name = defaults.name;
-            if (!typeSupplied)
+            }
+            if (!typeSupplied) {
                 type = defaults.type;
+            }
         }
         final Pathname p;
         final boolean logical;
         if (host != NIL) {
-            if (host instanceof AbstractString)
-                host = LogicalPathname.canonicalizeStringComponent((AbstractString)host);
+            if (host instanceof AbstractString) {
+                host = LogicalPathname.canonicalizeStringComponent((AbstractString) host);
+            }
             if (LOGICAL_PATHNAME_TRANSLATIONS.get(host) == null) {
                 // Not a defined logical pathname host.
                 error(new LispError(host.writeToString() + " is not defined as a logical pathname host."));
@@ -886,10 +1009,12 @@
         if (device != NIL) {
             if (logical) {
                 // "The device component of a logical pathname is always :UNSPECIFIC."
-                if (device != Keyword.UNSPECIFIC)
+                if (device != Keyword.UNSPECIFIC) {
                     error(new LispError("The device component of a logical pathname must be :UNSPECIFIC."));
-            } else
+                }
+            } else {
                 p.device = device;
+            }
         }
         if (directory != NIL) {
             if (logical) {
@@ -897,48 +1022,51 @@
                     LispObject d = NIL;
                     while (directory != NIL) {
                         LispObject component = directory.car();
-                        if (component instanceof AbstractString)
-                            d = d.push(LogicalPathname.canonicalizeStringComponent((AbstractString)component));
-                        else
+                        if (component instanceof AbstractString) {
+                            d = d.push(LogicalPathname.canonicalizeStringComponent((AbstractString) component));
+                        } else {
                             d = d.push(component);
+                        }
                         directory = directory.cdr();
                     }
                     p.directory = d.nreverse();
-                } else if (directory == Keyword.WILD || directory == Keyword.WILD_INFERIORS)
+                } else if (directory == Keyword.WILD || directory == Keyword.WILD_INFERIORS) {
                     p.directory = directory;
-                else
+                } else {
                     error(new LispError("Invalid directory component for logical pathname: " + directory.writeToString()));
-            } else
+                }
+            } else {
                 p.directory = directory;
+            }
         }
         if (name != NIL) {
-            if (logical && name instanceof AbstractString)
-                p.name = LogicalPathname.canonicalizeStringComponent((AbstractString)name);
-            else if (name instanceof AbstractString)
-                p.name = validateStringComponent((AbstractString)name);
-            else
+            if (logical && name instanceof AbstractString) {
+                p.name = LogicalPathname.canonicalizeStringComponent((AbstractString) name);
+            } else if (name instanceof AbstractString) {
+                p.name = validateStringComponent((AbstractString) name);
+            } else {
                 p.name = name;
+            }
         }
         if (type != NIL) {
-            if (logical && type instanceof AbstractString)
-                p.type = LogicalPathname.canonicalizeStringComponent((AbstractString)type);
-            else
+            if (logical && type instanceof AbstractString) {
+                p.type = LogicalPathname.canonicalizeStringComponent((AbstractString) type);
+            } else {
                 p.type = type;
+            }
         }
         p.version = version;
         return p;
     }
 
-    private static final AbstractString validateStringComponent(AbstractString s)
-
-    {
+    private static final AbstractString validateStringComponent(AbstractString s) {
         final int limit = s.length();
         for (int i = 0; i < limit; i++) {
             char c = s.charAt(i);
             if (c == '/' || c == '\\' && Utilities.isPlatformWindows) {
-                error(new LispError("Invalid character #\\" + c +
-                                    " in pathname component \"" + s +
-                                    '"'));
+                error(new LispError("Invalid character #\\" + c
+                  + " in pathname component \"" + s
+                  + '"'));
                 // Not reached.
                 return null;
             }
@@ -946,9 +1074,7 @@
         return s;
     }
 
-    private final boolean validateDirectory(boolean signalError)
-
-    {
+    private final boolean validateDirectory(boolean signalError) {
         LispObject temp = directory;
         while (temp != NIL) {
             LispObject first = temp.car();
